<?php

defined ('_JEXEC') or die('Restricted access');

/**
 * Plugin providing Custom variables for the VM Ordernumber plugin
 *
 * @subpackage Plugins - vm ordernumber
 * @copyright Copyright (C) 2014 Reinhold Kainhofer, office@open-tools.net
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
 *
 * http://open-tools.net/
 *
 */
if (!class_exists('vmShopperPlugin')) 
    require(JPATH_VM_PLUGINS . DS . 'vmshopperplugin.php');

/** Extension plugin for the Odernumber plugin for VirtueMart
 */
class plgVmShopperOrderNumber_ShopperGroups extends VmShopperPlugin {
    public function plgVmOnUpdateOrderBEShopper($_orderID) {}
    
	/**  Trigger to add variables to be used in the number formats
	  *  You can add new variables to the $cartvals array or modify existing ones. They will be directly 
	  *  available in all formats. This trigger will be called whenever the ordernumber plugin creates a 
	  *  number. All built-in variables are already set in the $reps variable, so you can even override
	  *  the built-in variables by changing $reps accordingly.
	  *  $nrtype is 0 for ordernumber, 1 for invoice number, 2 for customer number and 3 for order password
	  *  $details contains the order details
	  */
	function onVmOrdernumberGetVariables(&$reps, $fmt, $nrtype, $details) {
//         JFactory::getApplication()->enqueueMessage("<pre>Order Details: ".print_r($details,1)."</pre>", 'error');
//         JFactory::getApplication()->enqueueMessage("<pre>Plugin params: ".print_r($this->params,1)."</pre>", 'error');
        
        $groups = array();
        $uid = isset($details->virtuemart_user_id)?$details->virtuemart_user_id:0;
        if ($uid>0) {
            $userModel = VmModel::getModel('user');
            $xrefTable = $userModel->getTable('vmuser_shoppergroups');
            $groups = $xrefTable->load($uid);
        }

        foreach (range(1,6) as $i) {
            $grp = $this->params->get('group'.(int)$i, 0);
            $var = $this->params->get('variable'.(int)$i, null);
            if (is_null($var)) continue;
            $var = '['.strtolower($var).']';
            $val = $this->params->get('value'.(int)$i, null);
            
            $match = (($grp==0) || // Set default value
                      ($grp<0 && empty($groups)) || // NO group set, user does not have any groups
                      ($grp>0 && !empty($groups) && in_array($grp, $groups))); // Have a user with group -> check groups
            if ($match) {
                if (is_null($val)) 
                    unset($reps[$var]);
                else
                    $reps[$var] = $val;
            }
//             JFactory::getApplication()->enqueueMessage("<pre>group $i: grp=$grp, var=$var; val=$val, match=$match</pre>", 'error');
        }
//         JFactory::getApplication()->enqueueMessage("<pre>Replacements: ".print_r($reps,1).", groups: ".print_r($groups,1)."</pre>", 'error');
	}
}

// No closing tag
